diff --git a/gcc/tracer.c b/gcc/tracer.c
index 975cadb..084acb6 100644
--- a/gcc/tracer.c
+++ b/gcc/tracer.c
@@ -397,23 +397,32 @@ gate_tracer (void)
   return (optimize > 0 && flag_tracer && flag_reorder_blocks);
 }
 
-struct gimple_opt_pass pass_tracer =
+class pass_tracer : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "tracer",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tracer,                          /* gate */
-  tracer,                               /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_TRACER,                            /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_update_ssa
-    | TODO_verify_ssa                   /* todo_flags_finish */
- }
-};
+public:
+  pass_tracer(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tracer",
+		      OPTGROUP_NONE,
+		      TV_TRACER,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tracer (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tracer (); }
+
+}; // class pass_tracer
+
+gimple_opt_pass *
+make_pass_tracer (context &ctxt)
+{
+  return new pass_tracer (ctxt);
+}
diff --git a/gcc/trans-mem.c b/gcc/trans-mem.c
index b0f18b5..7e059b7 100644
--- a/gcc/trans-mem.c
+++ b/gcc/trans-mem.c
@@ -800,25 +800,35 @@ diagnose_tm_blocks (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_diagnose_tm_blocks =
+class pass_diagnose_tm_blocks : public gimple_opt_pass
 {
-  {
-    GIMPLE_PASS,
-    "*diagnose_tm_blocks",		/* name */
-    OPTGROUP_NONE,                      /* optinfo_flags */
-    gate_tm,				/* gate */
-    diagnose_tm_blocks,			/* execute */
-    NULL,				/* sub */
-    NULL,				/* next */
-    0,					/* static_pass_number */
-    TV_TRANS_MEM,			/* tv_id */
-    PROP_gimple_any,			/* properties_required */
-    0,					/* properties_provided */
-    0,					/* properties_destroyed */
-    0,					/* todo_flags_start */
-    0,					/* todo_flags_finish */
-  }
-};
+public:
+  pass_diagnose_tm_blocks(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*diagnose_tm_blocks",
+		      OPTGROUP_NONE,
+		      TV_TRANS_MEM,
+		      pass_properties(required(PROP_gimple_any),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tm (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return diagnose_tm_blocks (); }
+
+}; // class pass_diagnose_tm_blocks
+
+gimple_opt_pass *
+make_pass_diagnose_tm_blocks (context &ctxt)
+{
+  return new pass_diagnose_tm_blocks (ctxt);
+}
 
 /* Instead of instrumenting thread private memory, we save the
    addresses in a log which we later use to save/restore the addresses
@@ -1675,25 +1685,35 @@ execute_lower_tm (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_lower_tm =
-{
- {
-  GIMPLE_PASS,
-  "tmlower",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tm,				/* gate */
-  execute_lower_tm,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TRANS_MEM,				/* tv_id */
-  PROP_gimple_lcf,			/* properties_required */
-  0,			                /* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0,             		        /* todo_flags_finish */
- }
-};
+class pass_lower_tm : public gimple_opt_pass
+{
+public:
+  pass_lower_tm(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tmlower",
+		      OPTGROUP_NONE,
+		      TV_TRANS_MEM,
+		      pass_properties(required(PROP_gimple_lcf),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tm (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_lower_tm (); }
+
+}; // class pass_lower_tm
+
+gimple_opt_pass *
+make_pass_lower_tm (context &ctxt)
+{
+  return new pass_lower_tm (ctxt);
+}
 
 /* Collect region information for each transaction.  */
 
@@ -1937,25 +1957,35 @@ gate_tm_init (void)
   return true;
 }
 
-struct gimple_opt_pass pass_tm_init =
-{
- {
-  GIMPLE_PASS,
-  "*tminit",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tm_init,				/* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TRANS_MEM,				/* tv_id */
-  PROP_ssa | PROP_cfg,			/* properties_required */
-  0,			                /* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0,					/* todo_flags_finish */
- }
-};
+class pass_tm_init : public gimple_opt_pass
+{
+public:
+  pass_tm_init(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*tminit",
+		      OPTGROUP_NONE,
+		      TV_TRANS_MEM,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tm_init (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_tm_init
+
+gimple_opt_pass *
+make_pass_tm_init (context &ctxt)
+{
+  return new pass_tm_init (ctxt);
+}
 
 /* Add FLAGS to the GIMPLE_TRANSACTION subcode for the transaction region
    represented by STATE.  */
@@ -2896,26 +2926,35 @@ execute_tm_mark (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_tm_mark =
-{
- {
-  GIMPLE_PASS,
-  "tmmark",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_tm_mark,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TRANS_MEM,				/* tv_id */
-  PROP_ssa | PROP_cfg,			/* properties_required */
-  0,			                /* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_ssa, 			/* todo_flags_finish */
- }
-};
+class pass_tm_mark : public gimple_opt_pass
+{
+public:
+  pass_tm_mark(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tmmark",
+		      OPTGROUP_NONE,
+		      TV_TRANS_MEM,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_tm_mark (); }
+
+}; // class pass_tm_mark
+
+gimple_opt_pass *
+make_pass_tm_mark (context &ctxt)
+{
+  return new pass_tm_mark (ctxt);
+}
 
 
 /* Create an abnormal edge from STMT at iter, splitting the block
@@ -3063,26 +3102,35 @@ execute_tm_edges (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_tm_edges =
-{
- {
-  GIMPLE_PASS,
-  "tmedge",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_tm_edges,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TRANS_MEM,				/* tv_id */
-  PROP_ssa | PROP_cfg,			/* properties_required */
-  0,			                /* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_ssa,			/* todo_flags_finish */
- }
-};
+class pass_tm_edges : public gimple_opt_pass
+{
+public:
+  pass_tm_edges(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tmedge",
+		      OPTGROUP_NONE,
+		      TV_TRANS_MEM,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_tm_edges (); }
+
+}; // class pass_tm_edges
+
+gimple_opt_pass *
+make_pass_tm_edges (context &ctxt)
+{
+  return new pass_tm_edges (ctxt);
+}
 
 /* Helper function for expand_regions.  Expand REGION and recurse to
    the inner region.  Call CALLBACK on each region.  CALLBACK returns
@@ -3781,25 +3829,35 @@ gate_tm_memopt (void)
   return flag_tm && optimize > 0;
 }
 
-struct gimple_opt_pass pass_tm_memopt =
-{
- {
-  GIMPLE_PASS,
-  "tmmemopt",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tm_memopt,			/* gate */
-  execute_tm_memopt,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TRANS_MEM,				/* tv_id */
-  PROP_ssa | PROP_cfg,			/* properties_required */
-  0,			                /* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0,            			/* todo_flags_finish */
- }
-};
+class pass_tm_memopt : public gimple_opt_pass
+{
+public:
+  pass_tm_memopt(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "tmmemopt",
+		      OPTGROUP_NONE,
+		      TV_TRANS_MEM,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tm_memopt (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_tm_memopt (); }
+
+}; // class pass_tm_memopt
+
+gimple_opt_pass *
+make_pass_tm_memopt (context &ctxt)
+{
+  return new pass_tm_memopt (ctxt);
+}
 
 
 /* Interprocedual analysis for the creation of transactional clones.
@@ -5387,24 +5445,34 @@ ipa_tm_execute (void)
   return 0;
 }
 
-struct simple_ipa_opt_pass pass_ipa_tm =
-{
- {
-  SIMPLE_IPA_PASS,
-  "tmipa",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tm,				/* gate */
-  ipa_tm_execute,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TRANS_MEM,				/* tv_id */
-  PROP_ssa | PROP_cfg,			/* properties_required */
-  0,			                /* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0,					/* todo_flags_finish */
- },
-};
+class pass_ipa_tm : public simple_ipa_opt_pass
+{
+public:
+  pass_ipa_tm(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "tmipa",
+			  OPTGROUP_NONE,
+			  TV_TRANS_MEM,
+			  pass_properties(required(PROP_ssa | PROP_cfg),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tm (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return ipa_tm_execute (); }
+
+}; // class pass_ipa_tm
+
+simple_ipa_opt_pass *
+make_pass_ipa_tm (context &ctxt)
+{
+  return new pass_ipa_tm (ctxt);
+}
 
 #include "gt-trans-mem.h"
diff --git a/gcc/tree-call-cdce.c b/gcc/tree-call-cdce.c
index 9b6186e..cfb8e6f 100644
--- a/gcc/tree-call-cdce.c
+++ b/gcc/tree-call-cdce.c
@@ -913,22 +913,32 @@ gate_call_cdce (void)
   return flag_tree_builtin_call_dce != 0 && optimize_function_for_speed_p (cfun);
 }
 
-struct gimple_opt_pass pass_call_cdce =
+class pass_call_cdce : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "cdce",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_call_cdce,                       /* gate */
-  tree_call_cdce,                       /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_TREE_CALL_CDCE,                    /* tv_id */
-  PROP_cfg | PROP_ssa,                  /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_ssa                       /* todo_flags_finish */
- }
-};
+public:
+  pass_call_cdce(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cdce",
+		      OPTGROUP_NONE,
+		      TV_TREE_CALL_CDCE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_call_cdce (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_call_cdce (); }
+
+}; // class pass_call_cdce
+
+gimple_opt_pass *
+make_pass_call_cdce (context &ctxt)
+{
+  return new pass_call_cdce (ctxt);
+}
diff --git a/gcc/tree-cfg.c b/gcc/tree-cfg.c
index 05bac43..68a9c5b 100644
--- a/gcc/tree-cfg.c
+++ b/gcc/tree-cfg.c
@@ -223,25 +223,35 @@ execute_build_cfg (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_build_cfg =
-{
- {
-  GIMPLE_PASS,
-  "cfg",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_build_cfg,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_CFG,				/* tv_id */
-  PROP_gimple_leh, 			/* properties_required */
-  PROP_cfg,				/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_stmts | TODO_cleanup_cfg  /* todo_flags_finish */
- }
-};
+class pass_build_cfg : public gimple_opt_pass
+{
+public:
+  pass_build_cfg(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cfg",
+		      OPTGROUP_NONE,
+		      TV_TREE_CFG,
+		      pass_properties(required(PROP_gimple_leh),
+				      provided(PROP_cfg),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_stmts | TODO_cleanup_cfg)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_build_cfg (); }
+
+}; // class pass_build_cfg
+
+gimple_opt_pass *
+make_pass_build_cfg (context &ctxt)
+{
+  return new pass_build_cfg (ctxt);
+}
 
 
 /* Return true if T is a computed goto.  */
@@ -7794,25 +7804,35 @@ split_critical_edges (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_split_crit_edges =
-{
- {
-  GIMPLE_PASS,
-  "crited",                          /* name */
-  OPTGROUP_NONE,                 /* optinfo_flags */
-  NULL,                          /* gate */
-  split_critical_edges,          /* execute */
-  NULL,                          /* sub */
-  NULL,                          /* next */
-  0,                             /* static_pass_number */
-  TV_TREE_SPLIT_EDGES,           /* tv_id */
-  PROP_cfg,                      /* properties required */
-  PROP_no_crit_edges,            /* properties_provided */
-  0,                             /* properties_destroyed */
-  0,                             /* todo_flags_start */
-  TODO_verify_flow               /* todo_flags_finish */
- }
-};
+class pass_split_crit_edges : public gimple_opt_pass
+{
+public:
+  pass_split_crit_edges(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "crited",
+		      OPTGROUP_NONE,
+		      TV_TREE_SPLIT_EDGES,
+		      pass_properties(required(PROP_cfg),
+				      provided(PROP_no_crit_edges),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return split_critical_edges (); }
+
+}; // class pass_split_crit_edges
+
+gimple_opt_pass *
+make_pass_split_crit_edges (context &ctxt)
+{
+  return new pass_split_crit_edges (ctxt);
+}
 
 
 /* Build a ternary operation and gimplify it.  Emit code before GSI.
@@ -7948,25 +7968,35 @@ extract_true_false_edges_from_block (basic_block b,
     }
 }
 
-struct gimple_opt_pass pass_warn_function_return =
-{
- {
-  GIMPLE_PASS,
-  "*warn_function_return",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_warn_function_return,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_warn_function_return : public gimple_opt_pass
+{
+public:
+  pass_warn_function_return(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*warn_function_return",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_warn_function_return (); }
+
+}; // class pass_warn_function_return
+
+gimple_opt_pass *
+make_pass_warn_function_return (context &ctxt)
+{
+  return new pass_warn_function_return (ctxt);
+}
 
 /* Emit noreturn warnings.  */
 
@@ -7985,25 +8015,37 @@ gate_warn_function_noreturn (void)
   return warn_suggest_attribute_noreturn;
 }
 
-struct gimple_opt_pass pass_warn_function_noreturn =
-{
- {
-  GIMPLE_PASS,
-  "*warn_function_noreturn",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_warn_function_noreturn,		/* gate */
-  execute_warn_function_noreturn,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_warn_function_noreturn : public gimple_opt_pass
+{
+public:
+  pass_warn_function_noreturn(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*warn_function_noreturn",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_warn_function_noreturn (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return execute_warn_function_noreturn ();
+  }
+
+}; // class pass_warn_function_noreturn
+
+gimple_opt_pass *
+make_pass_warn_function_noreturn (context &ctxt)
+{
+  return new pass_warn_function_noreturn (ctxt);
+}
 
 
 /* Walk a gimplified function and warn for functions whose return value is
@@ -8084,25 +8126,35 @@ gate_warn_unused_result (void)
   return flag_warn_unused_result;
 }
 
-struct gimple_opt_pass pass_warn_unused_result =
-{
-  {
-    GIMPLE_PASS,
-    "*warn_unused_result",		/* name */
-    OPTGROUP_NONE,                        /* optinfo_flags */
-    gate_warn_unused_result,		/* gate */
-    run_warn_unused_result,		/* execute */
-    NULL,				/* sub */
-    NULL,				/* next */
-    0,					/* static_pass_number */
-    TV_NONE,				/* tv_id */
-    PROP_gimple_any,			/* properties_required */
-    0,					/* properties_provided */
-    0,					/* properties_destroyed */
-    0,					/* todo_flags_start */
-    0,					/* todo_flags_finish */
-  }
-};
+class pass_warn_unused_result : public gimple_opt_pass
+{
+public:
+  pass_warn_unused_result(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*warn_unused_result",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_gimple_any),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_warn_unused_result (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return run_warn_unused_result (); }
+
+}; // class pass_warn_unused_result
+
+gimple_opt_pass *
+make_pass_warn_unused_result (context &ctxt)
+{
+  return new pass_warn_unused_result (ctxt);
+}
 
 
 /* Garbage collection support for edge_def.  */
diff --git a/gcc/tree-cfgcleanup.c b/gcc/tree-cfgcleanup.c
index b355a86..492bb66 100644
--- a/gcc/tree-cfgcleanup.c
+++ b/gcc/tree-cfgcleanup.c
@@ -976,22 +976,32 @@ gate_merge_phi (void)
   return 1;
 }
 
-struct gimple_opt_pass pass_merge_phi =
+class pass_merge_phi : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "mergephi",			/* name */
-  OPTGROUP_NONE,                /* optinfo_flags */
-  gate_merge_phi,		/* gate */
-  merge_phi_nodes,		/* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_TREE_MERGE_PHI,		/* tv_id */
-  PROP_cfg | PROP_ssa,		/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  TODO_verify_ssa               /* todo_flags_finish */
- }
-};
+public:
+  pass_merge_phi(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "mergephi",
+		      OPTGROUP_NONE,
+		      TV_TREE_MERGE_PHI,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_merge_phi (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return merge_phi_nodes (); }
+
+}; // class pass_merge_phi
+
+gimple_opt_pass *
+make_pass_merge_phi (context &ctxt)
+{
+  return new pass_merge_phi (ctxt);
+}
diff --git a/gcc/tree-complex.c b/gcc/tree-complex.c
index 760083b..a9e7ceb 100644
--- a/gcc/tree-complex.c
+++ b/gcc/tree-complex.c
@@ -1632,26 +1632,35 @@ tree_lower_complex (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_lower_complex =
+class pass_lower_complex : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "cplxlower",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  0,					/* gate */
-  tree_lower_complex,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_ssa,				/* properties_required */
-  PROP_gimple_lcx,			/* properties_provided */
-  0,                       		/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_stmts	 		/* todo_flags_finish */
- }
-};
+public:
+  pass_lower_complex(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cplxlower",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(PROP_gimple_lcx),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_stmts)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_lower_complex (); }
+
+}; // class pass_lower_complex
+
+gimple_opt_pass *
+make_pass_lower_complex (context &ctxt)
+{
+  return new pass_lower_complex (ctxt);
+}
 
 
 static bool
@@ -1662,23 +1671,32 @@ gate_no_optimization (void)
   return !(cfun->curr_properties & PROP_gimple_lcx);
 }
 
-struct gimple_opt_pass pass_lower_complex_O0 =
+class pass_lower_complex_O0 : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "cplxlower0",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_no_optimization,			/* gate */
-  tree_lower_complex,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  PROP_gimple_lcx,			/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_stmts	 		/* todo_flags_finish */
- }
-};
+public:
+  pass_lower_complex_O0(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cplxlower0",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(PROP_gimple_lcx),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_stmts)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_no_optimization (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_lower_complex (); }
+
+}; // class pass_lower_complex_O0
+
+gimple_opt_pass *
+make_pass_lower_complex_O0 (context &ctxt)
+{
+  return new pass_lower_complex_O0 (ctxt);
+}
